#include "myFile.h"
/*
*********************************************************************************************************
*	  : int write_file(const char* filename, const char* data, uint32_t length)
*	    Σ*fileNameļϵͳ*dataҪдַ׵ַܹҪдݳȡ
*	  ֵ: 
*********************************************************************************************************
*/
void write_file(const char* filename, const char* data, uint32_t length)
{
  /* ʹõľֲռý϶࣬޸ļ֤ջռ乻 */
	FRESULT result;
	FATFS fs;
	FIL file;
	DIR DirInf;
	uint32_t bw;

 	/* ļϵͳ */
	result = f_mount(&fs, FS_VOLUME_NAND, 0);			/* Mount a logical drive */
	if (result != FR_OK)
	{
//		LOG_PRINT(LOG_ERROR,"(%d)\r\n", result);
		printf("ļϵͳʧ (%d)\r\n", result);
		
	}

	/* 򿪸ļ */
	result = f_opendir(&DirInf, "0:/"); /* 0: ʾ̷ */
	if(result==FR_NO_FILESYSTEM)  //ֵΪfilesystem򴴽ļϵͳ
	{
		result=f_mkfs("0:",0,0);
	}
	if (result != FR_OK)
	{	
//		LOG_PRINT(LOG_ERROR,"򿪸Ŀ¼ʧ (%d)\r\n", result);
		printf("򿪸Ŀ¼ʧ (%d)\r\n", result);
		return ;
	}
  char filepath[30];
  sprintf(filepath, "0:/%s", filename);//Ϊfilenamefilepathǰ׺

	/* ļ */
	result = f_open(&file, filepath, FA_CREATE_ALWAYS | FA_WRITE);

	/* дһ */
	result = f_write(&file,data, length, &bw);
	if (result == FR_OK)
	{
//		LOG_PRINT(LOG_INFO,"ļдɹ\r\n");
		printf("ļдɹ\r\n");
	}
	else
	{
//		LOG_PRINT(LOG_ERROR,"ļдʧ\r\n");
		printf("ļдʧ\r\n");
	}
	/* رļ*/
	f_close(&file);
	/* жļϵͳ */
	f_mount(NULL, FS_VOLUME_NAND, 0);
}

/*
*********************************************************************************************************
*	  : ReadFileData
*	˵: 
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void read_file(const char* filename, char* data)
{
	/* ʹõľֲռý϶࣬޸ļ֤ջռ乻 */
	FRESULT result;
	FATFS fs;
	FIL file;
	DIR DirInf;
	uint32_t bw;

 	/* ļϵͳ */
	result = f_mount(&fs, FS_VOLUME_NAND, 0);			/* Mount a logical drive */
	
	if (result != FR_OK)
	{
//		LOG_PRINT(LOG_ERROR,"ļϵͳʧ(%d)\r\n", result);
		printf("ļϵͳʧ(%d)\r\n", result);
	}

	/* 򿪸ļ */
	result = f_opendir(&DirInf, "0:/"); 
	if(result==FR_NO_FILESYSTEM)  //ֵΪfilesystem򴴽ļϵͳ
	{
		f_mkfs("0:",0,0);
	}
	if (result != FR_OK)
	{
//		LOG_PRINT(LOG_ERROR,"򿪸Ŀ¼ʧ(%d)\r\n", result);		
		printf("򿪸Ŀ¼ʧ(%d)\r\n", result);
		goto _exit_file;
	}
	char filepath[30];
  sprintf(filepath, "0:/%s", filename);//Ϊfilenamefilepathǰ׺
	/* ļ */
	result = f_open(&file, filepath, FA_OPEN_EXISTING | FA_READ);
	if (result !=  FR_OK)
	{
//		LOG_PRINT(LOG_ERROR,"Don't Find File \r\n");		
		printf("Don't Find File \r\n");		
		goto _exit_file;
	}

	/* ȡļ */

	result= f_read(&file, data, f_size(&file), &bw);
	if (bw > 0)
	{
		//LOG_PRINT(LOG_INFO,"\r\%s ļ : \r\n%s\r\n", filename,data);		
		printf("\r\%s ļ : \r\n%s\r\n", filename,data);		
	}
	else
	{
		//LOG_PRINT(LOG_INFO,"\r\%s ļ : \r\n%s\r\n", filename);	
		printf("\r\%s ļ : \r\n",filename);
	}
	_exit_file:
	/* رļ*/
	f_close(&file);

	/* жļϵͳ */
	f_mount(NULL, FS_VOLUME_NAND, 0);
}
/*
*********************************************************************************************************
*	  : ViewRootDir
*	˵: ʾSDĿ¼µļ
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void ViewRootDir(void)
{
	/* ʹõľֲռý϶࣬޸ļ֤ջռ乻 */
	FRESULT result;
	FATFS fs;
	DIR DirInf;
	FILINFO FileInf;
	uint32_t cnt = 0;
	char lfname[256];

 	/* ļϵͳ */
	result = f_mount(&fs, FS_VOLUME_NAND, 0);	/* Mount a logical drive */	
	if (result != FR_OK)
	{
//		LOG_PRINT(LOG_ERROR,"ļϵͳʧ(%d)\r\n", result);
		printf("ļϵͳʧ (%d)\r\n", result);
	}
	/* 򿪸ļ */
	result = f_opendir(&DirInf, "0:/"); /* 0: ʾ̷ */
	if (result != FR_OK)
	{
//		LOG_PRINT(LOG_ERROR,"򿪸Ŀ¼ʧ(%d)\r\n", result);
		printf("򿪸Ŀ¼ʧ (%d)\r\n", result);
		return;
	}

	/* ȡǰļµļĿ¼ */
	FileInf.lfname = lfname;
	FileInf.lfsize = 256;
//	LOG_PRINT(LOG_INFO," |  ļС | ļ | ļ\r\n");
	printf(" |  ļС | ļ | ļ\r\n");
	for (cnt = 0; ;cnt++)
	{
		result = f_readdir(&DirInf,&FileInf); 		/* ȡĿ¼Զ */
		if (result != FR_OK || FileInf.fname[0] == 0)
		{
			break;
		}

		if (FileInf.fname[0] == '.')
		{
			continue;
		}

		/* жļĿ¼ */
		if (FileInf.fattrib & AM_DIR)
		{
//			LOG_PRINT(LOG_INFO,"(0x%02d)Ŀ¼  ", FileInf.fattrib);
			printf("(0x%02d)Ŀ¼  ", FileInf.fattrib);			
		}
		else
		{
//			LOG_PRINT(LOG_INFO,"(0x%02d)ļ  ", FileInf.fattrib);	
			printf("(0x%02d)ļ  ", FileInf.fattrib);			
		}

//		/* ӡļС, 4G */
//		LOG_PRINT(LOG_INFO," %10d", FileInf.fsize);		
//		LOG_PRINT(LOG_INFO,"  %s |", FileInf.fname);

//		LOG_PRINT(LOG_INFO,"  %s\r\n", (char *)FileInf.lfname);
				/* ӡļС, 4G */
		printf(" %10d", FileInf.fsize);
		printf("  %s |", FileInf.fname);	/* ļ */

		printf("  %s\r\n", (char *)FileInf.lfname);	/* ļ */
	}

	/* жļϵͳ */
	f_mount(NULL, FS_VOLUME_NAND, 0);
}
/*
*********************************************************************************************************
*	  : DeleteDirFile
*	˵: ɾSDĿ¼µ armfly.txt ļ Dir1Dir2 Ŀ¼
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void DeleteDirFile(const char* filename)
{
	/* ʹõľֲռý϶࣬޸ļ֤ջռ乻 */
	FRESULT result;
	FATFS fs;
	char FileName[50];
	sprintf(FileName,"0:/%s",filename);
	uint8_t i;

 	/* ļϵͳ */
	result = f_mount(&fs, FS_VOLUME_NAND, 0);			/* Mount a logical drive */
	if (result != FR_OK)
	{
//		LOG_PRINT(LOG_ERROR,"ļϵͳʧ(%d)\r\n", result);
		printf("ļϵͳʧ (%d)\r\n", result);
	}

	#if 0
	/* 򿪸ļ */
	result = f_opendir(&DirInf, "0:/"); /* ӵǰĿ¼ʼ */
	if (result != FR_OK)
	{
//		LOG_PRINT(LOG_ERROR,"ļϵͳʧ(%d)\r\n", result);
		printf("򿪸Ŀ¼ʧ(%d)\r\n", result);
		return;
	}
	#endif
	/* ɾļ */
	result = f_unlink(FileName);
	if (result == FR_OK)
	{
//		LOG_PRINT(LOG_ERROR,"ɾļ %s ɹ\r\n",filename);
		printf("ɾļ %s ɹ\r\n",filename);		
	}
	else if (result == FR_NO_FILE)
	{
//		LOG_PRINT(LOG_ERROR,"ûзļĿ¼ :%s\r\n", filename);	
		printf("ûзļĿ¼ :%s\r\n", filename);
	}
	else
	{
//		LOG_PRINT(LOG_ERROR,"ɾ%sʧ( = %d) ļֻĿ¼ǿ\r\n",filename,result);	
		printf("ɾ%sʧ( = %d) ļֻĿ¼ǿ\r\n",filename,result);
	}
	/* жļϵͳ */
	f_mount(NULL, FS_VOLUME_NAND, 0);
}



